import eigenpy.eigenpy_pywrap
import typing

__all__ = [
    "AngleAxis",
    "ColPivHouseholderQR",
    "CompleteOrthogonalDecomposition",
    "ComputationInfo",
    "DecompositionOptions",
    "EigenSolver",
    "Exception",
    "FullPivHouseholderQR",
    "HouseholderQR",
    "LDLT",
    "LLT",
    "MINRES",
    "PermutationMatrix",
    "Quaternion",
    "SelfAdjointEigenSolver",
    "SimdInstructionSetsInUse",
    "SimplicialLDLT",
    "SimplicialLLT",
    "StdVec_MatrixXd",
    "StdVec_MatrixXi",
    "StdVec_VectorXd",
    "StdVec_VectorXi",
    "checkVersionAtLeast",
    "fromEulerAngles",
    "is_approx",
    "seed",
    "sharedMemory",
    "solvers",
    "toEulerAngles"
]

class AngleAxis():
    pass

class ColPivHouseholderQR():
    pass

class CompleteOrthogonalDecomposition():
    pass

class EigenSolver():
    pass

class Exception():
    pass

class FullPivHouseholderQR():
    pass

class HouseholderQR():
    pass

class LDLT():
    pass

class LLT():
    pass

class MINRES():
    pass

class PermutationMatrix():
    pass

class Quaternion():
    pass

class SelfAdjointEigenSolver():
    pass

class SimplicialLDLT():
    pass

class SimplicialLLT():
    pass

class StdVec_MatrixXd():
    pass

class StdVec_MatrixXi():
    pass

class StdVec_VectorXd():
    pass

class StdVec_VectorXi():
    pass

class solvers():
    pass

def SimdInstructionSetsInUse() -> str:
    """
    SimdInstructionSetsInUse() -> str :
        Get the set of SIMD instructions in use with Eigen.

        C++ signature :
            char const* SimdInstructionSetsInUse()
    """

def checkVersionAtLeast(major_version: int, minor_version: int, patch_version: int) -> bool:
    """
    checkVersionAtLeast( (int)major_version, (int)minor_version, (int)patch_version) -> bool :
        Checks if the current version of EigenPy is at least the version provided by the input arguments.

        C++ signature :
            bool checkVersionAtLeast(unsigned int,unsigned int,unsigned int)
    """

def fromEulerAngles(euler_angles: numpy.ndarray, a0: int, a1: int, a2: int) -> numpy.ndarray:
    """
    fromEulerAngles( (numpy.ndarray)euler_angles, (int)a0, (int)a1, (int)a2) -> numpy.ndarray :
        It returns the rotation matrix associated to the Euler angles using the convention defined by the triplet (a0,a1,a2).

        C++ signature :
            Eigen::Matrix<double, 3, 3, 0, 3, 3> fromEulerAngles(Eigen::Matrix<double, 3, 1, 0, 3, 1>,long,long,long)
    """

def is_approx(A: numpy.ndarray, B_: numpy.ndarray, prec: float = 1e-12) -> bool:
    """
    is_approx( (numpy.ndarray)A, (numpy.ndarray)B [, (float)prec=1e-12]) -> bool :
        Returns True if A is approximately equal to B, within the precision determined by prec.

        C++ signature :
            bool is_approx(Eigen::MatrixBase<Eigen::Matrix<double, -1, -1, 0, -1, -1> >,Eigen::MatrixBase<Eigen::Matrix<double, -1, -1, 0, -1, -1> > [,double=1e-12])

        C++ signature :
            bool is_approx(Eigen::MatrixBase<Eigen::Matrix<std::complex<double>, -1, -1, 0, -1, -1> >,Eigen::MatrixBase<Eigen::Matrix<std::complex<double>, -1, -1, 0, -1, -1> > [,double=1e-12])
    """

def seed(seed_value: int) -> None:
    """
    seed( (int)seed_value) -> None :
        Initialize the pseudo-random number generator with the argument seed_value.

        C++ signature :
            void seed(unsigned int)
    """

@typing.overload
def sharedMemory() -> bool:
    """
    sharedMemory( (bool)value) -> None :
        Share the memory when converting from Eigen to Numpy.

        C++ signature :
            void sharedMemory(bool)

        C++ signature :
            bool sharedMemory()
    """
@typing.overload
def sharedMemory(value: bool) -> None:
    pass

def toEulerAngles(rotation_matrix: numpy.ndarray, a0: int, a1: int, a2: int) -> numpy.ndarray:
    """
    toEulerAngles( (numpy.ndarray)rotation_matrix, (int)a0, (int)a1, (int)a2) -> numpy.ndarray :
        It returns the Euler-angles of the rotation matrix mat using the convention defined by the triplet (a0,a1,a2).

        C++ signature :
            Eigen::Matrix<double, 3, 1, 0, 3, 1> toEulerAngles(Eigen::Matrix<double, 3, 3, 0, 3, 3>,long,long,long)
    """

__eigen_version__ = '4.0.0'
__raw_version__ = '3.9.0'
__version__ = '3.9.0'
import numpy
_Shape = typing.Tuple[int, ...]

